(ns wanijo.instance.view
  (:require [hiccup.form :as hform]
            [ring.util.anti-forgery :refer [anti-forgery-field]]
            [formulare.core :as form]
            [wanijo.instance.domain :as domain]
            [wanijo.framework.view :as view]
            [wanijo.framework.routing :refer [path]]
            [wanijo.framework.time :refer [prettify-dt]]))

(defn list! [schema instances new-form req]
  (view/layout!
   :request req
   :content
   [[:h1 "All Instances of schema "
     [:span.schema-title__name (:name schema)]]
    [:table
     [:thead
      [:tr
       [:th "Name"]
       [:th "Updated"]
       [:th "Created"]]]
     [:tbody
      (for [instance instances]
        [:tr
         [:td
          [:a {:href (path :instance-show instance)}
           (:name instance)]]
         [:td (prettify-dt (:updated_at instance))]
         [:td (prettify-dt (:created_at instance))]])]]
    [:h1 "New Instance"]
    (hform/form-to [:post (path :instance-new)]
                   (form/render-widgets new-form {} req)
                   (hform/hidden-field "schema-uuid"
                                       (:uuid schema))
                   (hform/submit-button "Create!"))]))

(defn show! [instance req]
  (view/layout!
   :request req
   :content
   [[:h1 (:name instance)]
    [:dl
     (for [prop (:properties instance)]
       (list
        [:dt (:name (:attribute prop))]
        [:dd (:value prop)]))]]))
